From 021b7fe27044b12828ce68e01f5d354f477999c5 Mon Sep 17 00:00:00 2001
From: Vladimir Serbinenko <phcoder@gmail.com>
Date: Sat, 9 Nov 2013 21:29:11 +0100
Subject: [PATCH 08/14] Add new ports: i386-xen and x86_64-xen. This allows
 running GRUB in XEN PV environment and load kernels.

---
 ChangeLog                               |   5 +
 conf/Makefile.common                    |   3 +
 configure.ac                            |   6 +
 gentpl.py                               |   6 +-
 grub-core/Makefile.am                   |  18 +
 grub-core/Makefile.core.def             |  63 ++-
 grub-core/commands/boot.c               |   3 +-
 grub-core/commands/xen/lsxen.c          |  90 ++++
 grub-core/disk/xen/xendisk.c            | 453 ++++++++++++++++++++
 grub-core/io/offset.c                   | 111 +++++
 grub-core/kern/emu/main.c               |   6 +-
 grub-core/kern/i386/coreboot/init.c     |   5 +-
 grub-core/kern/i386/efi/init.c          |   5 +-
 grub-core/kern/i386/pc/init.c           |   5 +-
 grub-core/kern/i386/tsc.c               |  21 +
 grub-core/kern/i386/xen/hypercall.S     |  43 ++
 grub-core/kern/i386/xen/startup.S       |  38 ++
 grub-core/kern/ia64/efi/init.c          |   5 +-
 grub-core/kern/ieee1275/init.c          |   9 +-
 grub-core/kern/mips/arc/init.c          |   2 +-
 grub-core/kern/mips/loongson/init.c     |   2 +-
 grub-core/kern/mips/qemu_mips/init.c    |   2 +-
 grub-core/kern/x86_64/xen/hypercall.S   |  53 +++
 grub-core/kern/x86_64/xen/startup.S     |  38 ++
 grub-core/kern/xen/init.c               | 571 +++++++++++++++++++++++++
 grub-core/lib/i386/reboot.c             |   1 -
 grub-core/lib/i386/relocator.c          |  82 ----
 grub-core/lib/i386/relocator_common_c.c | 109 +++++
 grub-core/lib/i386/xen/relocator.S      | 146 +++++++
 grub-core/lib/legacy_parse.c            |   3 +
 grub-core/lib/relocator.c               |   2 +-
 grub-core/lib/x86_64/xen/relocator.S    | 154 +++++++
 grub-core/lib/xen/datetime.c            |  40 ++
 grub-core/lib/xen/halt.c                |  32 ++
 grub-core/lib/xen/reboot.c              |  32 ++
 grub-core/lib/xen/relocator.c           | 125 ++++++
 grub-core/loader/i386/xen.c             | 712 ++++++++++++++++++++++++++++++++
 grub-core/loader/i386/xen_file.c        |  91 ++++
 grub-core/loader/i386/xen_file32.c      |   7 +
 grub-core/loader/i386/xen_file64.c      |   7 +
 grub-core/loader/i386/xen_fileXX.c      | 344 +++++++++++++++
 grub-core/term/xen/console.c            | 122 ++++++
 include/grub/disk.h                     |   1 +
 include/grub/elf.h                      |   4 +
 include/grub/file.h                     |   6 +
 include/grub/i386/xen/hypercall.h       |  85 ++++
 include/grub/i386/xen/memory.h          |   0
 include/grub/kernel.h                   |   4 +-
 include/grub/offsets.h                  |   5 +
 include/grub/x86_64/xen/hypercall.h     |  34 ++
 include/grub/xen.h                      |  93 +++++
 include/grub/xen/relocator.h            |  44 ++
 include/grub/xen_file.h                 |  54 +++
 util/grub-mkimage.c                     | 196 +++------
 util/grub-mkimagexx.c                   | 308 ++++++++++++++
 55 files changed, 4155 insertions(+), 251 deletions(-)
 create mode 100644 grub-core/commands/xen/lsxen.c
 create mode 100644 grub-core/disk/xen/xendisk.c
 create mode 100644 grub-core/io/offset.c
 create mode 100644 grub-core/kern/i386/xen/hypercall.S
 create mode 100644 grub-core/kern/i386/xen/startup.S
 create mode 100644 grub-core/kern/x86_64/xen/hypercall.S
 create mode 100644 grub-core/kern/x86_64/xen/startup.S
 create mode 100644 grub-core/kern/xen/init.c
 create mode 100644 grub-core/lib/i386/relocator_common_c.c
 create mode 100644 grub-core/lib/i386/xen/relocator.S
 create mode 100644 grub-core/lib/x86_64/xen/relocator.S
 create mode 100644 grub-core/lib/xen/datetime.c
 create mode 100644 grub-core/lib/xen/halt.c
 create mode 100644 grub-core/lib/xen/reboot.c
 create mode 100644 grub-core/lib/xen/relocator.c
 create mode 100644 grub-core/loader/i386/xen.c
 create mode 100644 grub-core/loader/i386/xen_file.c
 create mode 100644 grub-core/loader/i386/xen_file32.c
 create mode 100644 grub-core/loader/i386/xen_file64.c
 create mode 100644 grub-core/loader/i386/xen_fileXX.c
 create mode 100644 grub-core/term/xen/console.c
 create mode 100644 include/grub/i386/xen/hypercall.h
 create mode 100644 include/grub/i386/xen/memory.h
 create mode 100644 include/grub/x86_64/xen/hypercall.h
 create mode 100644 include/grub/xen.h
 create mode 100644 include/grub/xen/relocator.h
 create mode 100644 include/grub/xen_file.h

diff --git a/ChangeLog b/ChangeLog
index 1f9193e..357f39a 100644
--- a/ChangeLog
+++ b/ChangeLog
@@ -1,3 +1,8 @@
+2013-11-09  Vladimir Serbinenko  <phcoder@gmail.com>
+
+	Add new ports: i386-xen and x86_64-xen. This allows running GRUB in
+	XEN PV environment and load kernels.
+
 2013-10-28  Vladimir Serbinenko  <phcoder@gmail.com>
 
 	Make / in btrfs refer to real root, not the default volume.
diff --git a/conf/Makefile.common b/conf/Makefile.common
index 71d03fe..df78f53 100644
--- a/conf/Makefile.common
+++ b/conf/Makefile.common
@@ -38,6 +38,9 @@ if COND_sparc64_ieee1275
   LDFLAGS_PLATFORM = -Wl,-melf64_sparc -mno-relax
 endif
 
+#FIXME: discover and check XEN headers
+CPPFLAGS_XEN = -I/usr/include
+
 # Other options
 
 CPPFLAGS_DEFAULT = -DGRUB_FILE=\"$(subst $(srcdir)/,,$<)\"
diff --git a/configure.ac b/configure.ac
index 5ea7ffe..afd5104 100644
--- a/configure.ac
+++ b/configure.ac
@@ -108,6 +108,7 @@ fi
 case "$target_cpu"-"$platform" in
   x86_64-efi) ;;
   x86_64-emu) ;;
+  x86_64-xen) ;;
   x86_64-*) target_cpu=i386 ;;
   powerpc64-ieee1275) target_cpu=powerpc ;;
 esac
@@ -116,6 +117,8 @@ esac
 case "$target_cpu"-"$platform" in
   i386-efi) ;;
   x86_64-efi) ;;
+  i386-xen) ;;
+  x86_64-xen) ;;
   i386-pc) ;;
   i386-multiboot) ;;
   i386-coreboot) ;;
@@ -163,6 +166,7 @@ case "$platform" in
   coreboot)	machine_CPPFLAGS="$machine_CPPFLAGS -DGRUB_MACHINE_COREBOOT=1" ;;
   multiboot)	machine_CPPFLAGS="$machine_CPPFLAGS -DGRUB_MACHINE_MULTIBOOT=1" ;;
   efi)		machine_CPPFLAGS="$machine_CPPFLAGS -DGRUB_MACHINE_EFI=1" ;;
+  xen)		machine_CPPFLAGS="$machine_CPPFLAGS -DGRUB_MACHINE_XEN=1" ;;
   ieee1275)	machine_CPPFLAGS="$machine_CPPFLAGS -DGRUB_MACHINE_IEEE1275=1" ;;
   qemu)		machine_CPPFLAGS="$machine_CPPFLAGS -DGRUB_MACHINE_QEMU=1" ;;
   pc)		machine_CPPFLAGS="$machine_CPPFLAGS -DGRUB_MACHINE_PCBIOS=1" ;;
@@ -1107,6 +1111,8 @@ AM_CONDITIONAL([COND_i386_ieee1275], [test x$target_cpu = xi386 -a x$platform =
 AM_CONDITIONAL([COND_i386_coreboot], [test x$target_cpu = xi386 -a x$platform = xcoreboot])
 AM_CONDITIONAL([COND_i386_multiboot], [test x$target_cpu = xi386 -a x$platform = xmultiboot])
 AM_CONDITIONAL([COND_x86_64_efi], [test x$target_cpu = xx86_64 -a x$platform = xefi])
+AM_CONDITIONAL([COND_i386_xen], [test x$target_cpu = xi386 -a x$platform = xxen])
+AM_CONDITIONAL([COND_x86_64_xen], [test x$target_cpu = xx86_64 -a x$platform = xxen])
 AM_CONDITIONAL([COND_mips_loongson], [test x$target_cpu = xmipsel -a x$platform = xloongson])
 AM_CONDITIONAL([COND_mips_qemu_mips], [test "(" x$target_cpu = xmips -o x$target_cpu = xmipsel ")"  -a x$platform = xqemu_mips])
 AM_CONDITIONAL([COND_mips_arc], [test x$target_cpu = xmips -a x$platform = xarc])
diff --git a/gentpl.py b/gentpl.py
index 13a6081..edd52b8 100644
--- a/gentpl.py
+++ b/gentpl.py
@@ -21,6 +21,7 @@
 
 GRUB_PLATFORMS = [ "emu", "i386_pc", "i386_efi", "i386_qemu", "i386_coreboot",
                    "i386_multiboot", "i386_ieee1275", "x86_64_efi",
+                   "i386_xen", "x86_64_xen",
                    "mips_loongson", "sparc64_ieee1275",
                    "powerpc_ieee1275", "mips_arc", "ia64_efi",
                    "mips_qemu_mips" ]
@@ -40,6 +41,7 @@ GROUPS["powerpc"]  = [ "powerpc_ieee1275" ]
 # Groups based on firmware
 GROUPS["efi"]  = [ "i386_efi", "x86_64_efi", "ia64_efi" ]
 GROUPS["ieee1275"]   = [ "i386_ieee1275", "sparc64_ieee1275", "powerpc_ieee1275" ]
+GROUPS["xen"]  = [ "i386_xen", "x86_64_xen" ]
 
 # emu is a special case so many core functionality isn't needed on this platform
 GROUPS["noemu"]   = GRUB_PLATFORMS[:]; GROUPS["noemu"].remove("emu")
@@ -47,7 +49,7 @@ GROUPS["noemu"]   = GRUB_PLATFORMS[:]; GROUPS["noemu"].remove("emu")
 # Groups based on hardware features
 GROUPS["cmos"] = GROUPS["x86"][:] + ["mips_loongson", "mips_qemu_mips",
                                      "sparc64_ieee1275", "powerpc_ieee1275"]
-GROUPS["cmos"].remove("i386_efi"); GROUPS["cmos"].remove("x86_64_efi")
+GROUPS["cmos"].remove("i386_efi"); GROUPS["cmos"].remove("x86_64_efi");
 GROUPS["pci"]      = GROUPS["x86"] + ["mips_loongson"]
 GROUPS["usb"]      = GROUPS["pci"]
 
@@ -57,7 +59,7 @@ GROUPS["videomodules"]   = GRUB_PLATFORMS[:];
 for i in GROUPS["videoinkernel"]: GROUPS["videomodules"].remove(i)
 
 # Similar for terminfo
-GROUPS["terminfoinkernel"] = ["mips_loongson", "mips_arc", "mips_qemu_mips" ] + GROUPS["ieee1275"];
+GROUPS["terminfoinkernel"] = ["mips_loongson", "mips_arc", "mips_qemu_mips" ] + GROUPS["xen"] + GROUPS["ieee1275"];
 GROUPS["terminfomodule"]   = GRUB_PLATFORMS[:];
 for i in GROUPS["terminfoinkernel"]: GROUPS["terminfomodule"].remove(i)
 
diff --git a/grub-core/Makefile.am b/grub-core/Makefile.am
index 664c9ec..9ab8200 100644
--- a/grub-core/Makefile.am
+++ b/grub-core/Makefile.am
@@ -131,6 +131,24 @@ KERNEL_HEADER_FILES += $(top_srcdir)/include/grub/lib/arg.h
 KERNEL_HEADER_FILES += $(top_srcdir)/include/grub/i386/tsc.h
 endif
 
+if COND_i386_xen
+KERNEL_HEADER_FILES += $(top_srcdir)/include/grub/xen.h
+KERNEL_HEADER_FILES += $(top_srcdir)/include/grub/i386/xen/hypercall.h
+KERNEL_HEADER_FILES += $(top_srcdir)/include/grub/terminfo.h
+KERNEL_HEADER_FILES += $(top_srcdir)/include/grub/extcmd.h
+KERNEL_HEADER_FILES += $(top_srcdir)/include/grub/lib/arg.h
+KERNEL_HEADER_FILES += $(top_srcdir)/include/grub/loader.h
+endif
+
+if COND_x86_64_xen
+KERNEL_HEADER_FILES += $(top_srcdir)/include/grub/xen.h
+KERNEL_HEADER_FILES += $(top_srcdir)/include/grub/x86_64/xen/hypercall.h
+KERNEL_HEADER_FILES += $(top_srcdir)/include/grub/terminfo.h
+KERNEL_HEADER_FILES += $(top_srcdir)/include/grub/extcmd.h
+KERNEL_HEADER_FILES += $(top_srcdir)/include/grub/lib/arg.h
+KERNEL_HEADER_FILES += $(top_srcdir)/include/grub/loader.h
+endif
+
 if COND_x86_64_efi
 KERNEL_HEADER_FILES += $(top_srcdir)/include/grub/efi/efi.h
 KERNEL_HEADER_FILES += $(top_srcdir)/include/grub/efi/disk.h
diff --git a/grub-core/Makefile.core.def b/grub-core/Makefile.core.def
index 69bdb67..13fc58c 100644
--- a/grub-core/Makefile.core.def
+++ b/grub-core/Makefile.core.def
@@ -45,6 +45,11 @@ kernel = {
   ia64_efi_ldflags = '-Wl,-r,-d';
   ia64_efi_stripflags = '--strip-unneeded -K start -R .note -R .comment -R .note.gnu.gold-version';
 
+  x86_64_xen_ldflags       = '-Wl,-Ttext=0';
+  x86_64_xen_cppflags	   = '$(CPPFLAGS_XEN)';
+  i386_xen_ldflags       = '-Wl,-Ttext=0';
+  i386_xen_cppflags	   = '$(CPPFLAGS_XEN)';
+
   i386_pc_ldflags          = '$(TARGET_IMG_LDFLAGS)';
   i386_pc_ldflags          = '$(TARGET_IMG_BASE_LDOPT),0x9000';
 
@@ -70,6 +75,8 @@ kernel = {
   i386_pc_startup = kern/i386/pc/startup.S;
   i386_efi_startup = kern/i386/efi/startup.S;
   x86_64_efi_startup = kern/x86_64/efi/startup.S;
+  i386_xen_startup = kern/i386/xen/startup.S;
+  x86_64_xen_startup = kern/x86_64/xen/startup.S;
   i386_qemu_startup = kern/i386/qemu/startup.S;
   i386_ieee1275_startup = kern/i386/ieee1275/startup.S;
   i386_coreboot_startup = kern/i386/coreboot/startup.S;
@@ -118,6 +125,7 @@ kernel = {
   terminfoinkernel = lib/arg.c;
 
   i386 = kern/i386/dl.c;
+  i386_xen = kern/i386/dl.c;
 
   i386_coreboot_multiboot_qemu = kern/i386/coreboot/init.c;
   i386_coreboot_multiboot_qemu = term/i386/pc/vga_text.c;
@@ -136,11 +144,20 @@ kernel = {
   i386_efi = bus/pci.c;
 
   x86_64_efi = kern/i386/tsc.c;
-  x86_64_efi = kern/x86_64/dl.c;
+  x86_64 = kern/x86_64/dl.c;
+  x86_64_xen = kern/x86_64/dl.c;
   x86_64_efi = kern/x86_64/efi/callwrap.S;
   x86_64_efi = kern/i386/efi/init.c;
   x86_64_efi = bus/pci.c;
 
+  xen = kern/i386/tsc.c;
+  x86_64_xen = kern/x86_64/xen/hypercall.S;
+  i386_xen = kern/i386/xen/hypercall.S;
+  xen = kern/xen/init.c;
+  xen = term/xen/console.c;
+  xen = disk/xen/xendisk.c;
+  xen = commands/boot.c;
+
   ia64_efi = kern/ia64/efi/startup.S;
   ia64_efi = kern/ia64/efi/init.c;
   ia64_efi = kern/ia64/dl.c;
@@ -491,6 +508,14 @@ module = {
   enable = mips_arc;
 };
 
+module = {
+  name = lsxen;
+  common = commands/xen/lsxen.c;
+  cppflags = '$(CPPFLAGS_XEN)';
+
+  enable = xen;
+};
+
 library = {
   name = libgnulib.a;
   common = gnulib/regex.c;
@@ -598,8 +623,10 @@ module = {
 
 module = {
   name = cpuid;
-  x86 = commands/i386/cpuid.c;
+  common = commands/i386/cpuid.c;
   enable = x86;
+  enable = i386_xen;
+  enable = x86_64_xen;
 };
 
 module = {
@@ -651,6 +678,8 @@ module = {
   i386_multiboot = lib/i386/halt.c;
   i386_coreboot = lib/i386/halt.c;
   i386_qemu = lib/i386/halt.c;
+  xen = lib/xen/halt.c;
+  xen_cppflags = '$(CPPFLAGS_XEN)';
   efi = lib/efi/halt.c;
   ieee1275 = lib/ieee1275/halt.c;
   emu = lib/emu/halt.c;
@@ -667,6 +696,8 @@ module = {
   mips_arc = lib/mips/arc/reboot.c;
   mips_loongson = lib/mips/loongson/reboot.c;
   mips_qemu_mips = lib/mips/qemu_mips/reboot.c;
+  xen = lib/xen/reboot.c;
+  xen_cppflags = '$(CPPFLAGS_XEN)';
   common = commands/reboot.c;
 };
 
@@ -1251,6 +1282,11 @@ module = {
 };
 
 module = {
+  name = offsetio;
+  common = io/offset.c;
+};
+
+module = {
   name = bufio;
   common = io/bufio.c;
   enable = videomodules;
@@ -1281,13 +1317,21 @@ module = {
   x86 = lib/i386/relocator64.S;
   i386 = lib/i386/relocator_asm.S;
   x86_64 = lib/x86_64/relocator_asm.S;
+  i386_xen = lib/i386/relocator_asm.S;
+  x86_64_xen = lib/x86_64/relocator_asm.S;
   x86 = lib/i386/relocator.c;
+  x86 = lib/i386/relocator_common_c.c;
   ieee1275 = lib/ieee1275/relocator.c;
   efi = lib/efi/relocator.c;
   mips = lib/mips/relocator_asm.S;
   mips = lib/mips/relocator.c;
   powerpc = lib/powerpc/relocator_asm.S;
   powerpc = lib/powerpc/relocator.c;
+  xen = lib/xen/relocator.c;
+  i386_xen = lib/i386/xen/relocator.S;
+  x86_64_xen = lib/x86_64/xen/relocator.S;
+  xen = lib/i386/relocator_common_c.c;
+  xen_cppflags = '$(CPPFLAGS_XEN)';
 
   extra_dist = lib/i386/relocator_common.S;
   extra_dist = kern/powerpc/cache_flush.S;
@@ -1295,6 +1339,7 @@ module = {
   enable = mips;
   enable = powerpc;
   enable = x86;
+  enable = xen;
 };
 
 module = {
@@ -1305,6 +1350,8 @@ module = {
   powerpc_ieee1275 = lib/ieee1275/datetime.c;
   sparc64_ieee1275 = lib/ieee1275/cmos.c;
   powerpc_ieee1275 = lib/ieee1275/cmos.c;
+  xen = lib/xen/datetime.c;
+  xen_cppflags = '$(CPPFLAGS_XEN)';
 
   mips_arc = lib/arc/datetime.c;
   enable = noemu;
@@ -1394,6 +1441,12 @@ module = {
 module = {
   name = linux;
   x86 = loader/i386/linux.c;
+  xen = loader/i386/xen.c;
+  xen = loader/i386/xen_file.c;
+  xen = loader/i386/xen_file32.c;
+  xen = loader/i386/xen_file64.c;
+  extra_dist = loader/i386/xen_fileXX.c;
+  xen_cppflags	   = '$(CPPFLAGS_XEN)';
   i386_pc = lib/i386/pc/vesa_modes_table.c;
   mips = loader/mips/linux.c;
   powerpc_ieee1275 = loader/powerpc/ieee1275/linux.c;
@@ -1767,8 +1820,10 @@ module = {
   common = commands/legacycfg.c;
   common = lib/legacy_parse.c;
   emu = lib/i386/pc/vesa_modes_table.c;
+  xen = lib/i386/pc/vesa_modes_table.c;
   enable = i386_pc;
   enable = emu;
+  enable = xen;
 };
 
 module = {
@@ -1802,8 +1857,12 @@ module = {
 module = {
   name = backtrace;
   x86 = lib/i386/backtrace.c;
+  i386_xen = lib/i386/backtrace.c;
+  x86_64_xen = lib/i386/backtrace.c;
   common = lib/backtrace.c;
   enable = x86;
+  enable = i386_xen;
+  enable = x86_64_xen;
 };
 
 module = {
diff --git a/grub-core/commands/boot.c b/grub-core/commands/boot.c
index e0148c7..bbca81e 100644
--- a/grub-core/commands/boot.c
+++ b/grub-core/commands/boot.c
@@ -146,8 +146,7 @@ grub_loader_boot (void)
     return grub_error (GRUB_ERR_NO_KERNEL,
 		       N_("you need to load the kernel first"));
 
-  if (grub_loader_flags & GRUB_LOADER_FLAG_NORETURN)
-    grub_machine_fini ();
+  grub_machine_fini (grub_loader_flags);
 
   for (cur = preboots_head; cur; cur = cur->next)
     {
diff --git a/grub-core/commands/xen/lsxen.c b/grub-core/commands/xen/lsxen.c
new file mode 100644
index 0000000..8415495
--- /dev/null
+++ b/grub-core/commands/xen/lsxen.c
@@ -0,0 +1,90 @@
+/*
+ *  GRUB  --  GRand Unified Bootloader
+ *  Copyright (C) 2011  Free Software Foundation, Inc.
+ *
+ *  GRUB is free software: you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation, either version 3 of the License, or
+ *  (at your option) any later version.
+ *
+ *  GRUB is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with GRUB.  If not, see <http://www.gnu.org/licenses/>.
+ */
+
+#include <grub/dl.h>
+#include <grub/misc.h>
+#include <grub/command.h>
+#include <grub/i18n.h>
+#include <grub/xen.h>
+#include <grub/term.h>
+
+GRUB_MOD_LICENSE ("GPLv3+");
+
+static int
+hook (const char *dir, void *hook_data __attribute__ ((unused)))
+{
+  grub_printf ("%s\n", dir);
+  return 0;
+}
+
+static grub_err_t
+grub_cmd_lsxen (grub_command_t cmd __attribute__ ((unused)),
+		int argc, char **args)
+{
+  char *dir;
+  grub_err_t err;
+  char *buf;
+
+  if (argc >= 1)
+    return grub_xenstore_dir (args[0], hook, NULL);
+
+  buf = grub_xenstore_get_file ("domid", NULL);
+  if (!buf)
+    return grub_errno;
+  dir = grub_xasprintf ("/local/domain/%s", buf);
+  grub_free (buf);
+  err = grub_xenstore_dir (dir, hook, NULL);
+  grub_free (dir);
+  return err;
+}
+
+static grub_err_t
+grub_cmd_catxen (grub_command_t cmd __attribute__ ((unused)),
+		 int argc, char **args)
+{
+  const char *dir = "domid";
+  char *buf;
+
+  if (argc >= 1)
+    dir = args[0];
+
+  buf = grub_xenstore_get_file (dir, NULL);
+  if (!buf)
+    return grub_errno;
+  grub_xputs (buf);
+  grub_xputs ("\n");
+  grub_free (buf);
+  return GRUB_ERR_NONE;
+
+}
+
+static grub_command_t cmd_ls, cmd_cat;
+
+GRUB_MOD_INIT (lsxen)
+{
+  cmd_ls = grub_register_command ("xen_ls", grub_cmd_lsxen, "[DIR]",
+				  N_("List XEN storage."));
+  cmd_cat = grub_register_command ("xen_cat", grub_cmd_catxen, "[DIR]",
+				   N_("List XEN storage."));
+}
+
+GRUB_MOD_FINI (lsxen)
+{
+  grub_unregister_command (cmd_ls);
+  grub_unregister_command (cmd_cat);
+}
diff --git a/grub-core/disk/xen/xendisk.c b/grub-core/disk/xen/xendisk.c
new file mode 100644
index 0000000..c449848
--- /dev/null
+++ b/grub-core/disk/xen/xendisk.c
@@ -0,0 +1,453 @@
+/*
+ *  GRUB  --  GRand Unified Bootloader
+ *  Copyright (C) 2013  Free Software Foundation, Inc.
+ *
+ *  GRUB is free software: you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation, either version 3 of the License, or
+ *  (at your option) any later version.
+ *
+ *  GRUB is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with GRUB.  If not, see <http://www.gnu.org/licenses/>.
+ */
+
+#include <grub/disk.h>
+#include <grub/dl.h>
+#include <grub/mm.h>
+#include <grub/types.h>
+#include <grub/misc.h>
+#include <grub/err.h>
+#include <grub/term.h>
+#include <grub/i18n.h>
+#include <grub/xen.h>
+#include <grub/time.h>
+#include <xen/io/blkif.h>
+
+struct virtdisk
+{
+  int handle;
+  char *fullname;
+  char *backend_dir;
+  char *frontend_dir;
+  struct blkif_sring *shared_page;
+  struct blkif_front_ring ring;
+  grub_xen_grant_t grant;
+  grub_xen_evtchn_t evtchn;
+  void *dma_page;
+  grub_xen_grant_t dma_grant;
+};
+
+#define xen_wmb() mb()
+#define xen_mb() mb()
+
+static struct virtdisk *virtdisks;
+static grub_size_t vdiskcnt;
+
+static int
+grub_virtdisk_iterate (grub_disk_dev_iterate_hook_t hook, void *hook_data,
+		       grub_disk_pull_t pull)
+{
+  grub_size_t i;
+
+  if (pull != GRUB_DISK_PULL_NONE)
+    return 0;
+
+  for (i = 0; i < vdiskcnt; i++)
+    if (hook (virtdisks[i].fullname, hook_data))
+      return 1;
+  return 0;
+}
+
+static grub_err_t
+grub_virtdisk_open (const char *name, grub_disk_t disk)
+{
+  grub_size_t i;
+  grub_uint32_t secsize;
+  char fdir[200];
+  char *buf;
+
+  for (i = 0; i < vdiskcnt; i++)
+    if (grub_strcmp (name, virtdisks[i].fullname) == 0)
+      break;
+  if (i == vdiskcnt)
+    return grub_error (GRUB_ERR_UNKNOWN_DEVICE, "not a virtdisk");
+  disk->data = &virtdisks[i];
+  disk->id = i;
+
+  grub_snprintf (fdir, sizeof (fdir), "%s/sectors", virtdisks[i].backend_dir);
+  buf = grub_xenstore_get_file (fdir, NULL);
+  if (!buf)
+    return grub_errno;
+  disk->total_sectors = grub_strtoull (buf, 0, 10);
+  if (grub_errno)
+    return grub_errno;
+
+  grub_snprintf (fdir, sizeof (fdir), "%s/sector-size",
+		 virtdisks[i].backend_dir);
+  buf = grub_xenstore_get_file (fdir, NULL);
+  if (!buf)
+    return grub_errno;
+  secsize = grub_strtoull (buf, 0, 10);
+  if (grub_errno)
+    return grub_errno;
+
+  if ((secsize & (secsize - 1)) || !secsize || secsize < 512
+      || secsize > GRUB_XEN_PAGE_SIZE)
+    return grub_error (GRUB_ERR_IO, "unsupported sector size %d", secsize);
+
+  for (disk->log_sector_size = 0;
+       (1U << disk->log_sector_size) < secsize; disk->log_sector_size++);
+
+  disk->total_sectors >>= disk->log_sector_size - 9;
+
+  return GRUB_ERR_NONE;
+}
+
+static void
+grub_virtdisk_close (grub_disk_t disk __attribute__ ((unused)))
+{
+}
+
+static grub_err_t
+grub_virtdisk_read (grub_disk_t disk, grub_disk_addr_t sector,
+		    grub_size_t size, char *buf)
+{
+  struct virtdisk *data = disk->data;
+
+  while (size)
+    {
+      grub_size_t cur;
+      struct blkif_request *req;
+      struct blkif_response *resp;
+      int sta = 0;
+      struct evtchn_send send;
+      cur = size;
+      if (cur > (unsigned) (GRUB_XEN_PAGE_SIZE >> disk->log_sector_size))
+	cur = GRUB_XEN_PAGE_SIZE >> disk->log_sector_size;
+      while (RING_FULL (&data->ring))
+	grub_xen_sched_op (SCHEDOP_yield, 0);
+      req = RING_GET_REQUEST (&data->ring, data->ring.req_prod_pvt);
+      req->operation = BLKIF_OP_READ;
+      req->nr_segments = 1;
+      req->handle = data->handle;
+      req->id = 0;
+      req->sector_number = sector << (disk->log_sector_size - 9);
+      req->seg[0].gref = data->dma_grant;
+      req->seg[0].first_sect = 0;
+      req->seg[0].last_sect = (cur << (disk->log_sector_size - 9)) - 1;
+      data->ring.req_prod_pvt++;
+      RING_PUSH_REQUESTS (&data->ring);
+      mb ();
+      send.port = data->evtchn;
+      grub_xen_event_channel_op (EVTCHNOP_send, &send);
+
+      while (!RING_HAS_UNCONSUMED_RESPONSES (&data->ring))
+	{
+	  grub_xen_sched_op (SCHEDOP_yield, 0);
+	  mb ();
+	}
+      while (1)
+	{
+	  int wtd;
+	  RING_FINAL_CHECK_FOR_RESPONSES (&data->ring, wtd);
+	  if (!wtd)
+	    break;
+	  resp = RING_GET_RESPONSE (&data->ring, data->ring.rsp_cons);
+	  data->ring.rsp_cons++;
+	  if (resp->status)
+	    sta = resp->status;
+	}
+      if (sta)
+	return grub_error (GRUB_ERR_IO, "read failed");
+      grub_memcpy (buf, data->dma_page, cur << disk->log_sector_size);
+      size -= cur;
+      sector += cur;
+      buf += cur << disk->log_sector_size;
+    }
+  return GRUB_ERR_NONE;
+}
+
+static grub_err_t
+grub_virtdisk_write (grub_disk_t disk, grub_disk_addr_t sector,
+		     grub_size_t size, const char *buf)
+{
+  struct virtdisk *data = disk->data;
+
+  while (size)
+    {
+      grub_size_t cur;
+      struct blkif_request *req;
+      struct blkif_response *resp;
+      int sta = 0;
+      struct evtchn_send send;
+      cur = size;
+      if (cur > (unsigned) (GRUB_XEN_PAGE_SIZE >> disk->log_sector_size))
+	cur = GRUB_XEN_PAGE_SIZE >> disk->log_sector_size;
+
+      grub_memcpy (data->dma_page, buf, cur << disk->log_sector_size);
+
+      while (RING_FULL (&data->ring))
+	grub_xen_sched_op (SCHEDOP_yield, 0);
+      req = RING_GET_REQUEST (&data->ring, data->ring.req_prod_pvt);
+      req->operation = BLKIF_OP_WRITE;
+      req->nr_segments = 1;
+      req->handle = data->handle;
+      req->id = 0;
+      req->sector_number = sector << (disk->log_sector_size - 9);
+      req->seg[0].gref = data->dma_grant;
+      req->seg[0].first_sect = 0;
+      req->seg[0].last_sect = (cur << (disk->log_sector_size - 9)) - 1;
+      data->ring.req_prod_pvt++;
+      RING_PUSH_REQUESTS (&data->ring);
+      mb ();
+      send.port = data->evtchn;
+      grub_xen_event_channel_op (EVTCHNOP_send, &send);
+
+      while (!RING_HAS_UNCONSUMED_RESPONSES (&data->ring))
+	{
+	  grub_xen_sched_op (SCHEDOP_yield, 0);
+	  mb ();
+	}
+      while (1)
+	{
+	  int wtd;
+	  RING_FINAL_CHECK_FOR_RESPONSES (&data->ring, wtd);
+	  if (!wtd)
+	    break;
+	  resp = RING_GET_RESPONSE (&data->ring, data->ring.rsp_cons);
+	  data->ring.rsp_cons++;
+	  if (resp->status)
+	    sta = resp->status;
+	}
+      if (sta)
+	return grub_error (GRUB_ERR_IO, "write failed");
+      size -= cur;
+      sector += cur;
+      buf += cur << disk->log_sector_size;
+    }
+  return GRUB_ERR_NONE;
+}
+
+static struct grub_disk_dev grub_virtdisk_dev = {
+  .name = "xen",
+  .id = GRUB_DISK_DEVICE_XEN,
+  .iterate = grub_virtdisk_iterate,
+  .open = grub_virtdisk_open,
+  .close = grub_virtdisk_close,
+  .read = grub_virtdisk_read,
+  .write = grub_virtdisk_write,
+  .next = 0
+};
+
+static int
+count (const char *dir __attribute__ ((unused)), void *data)
+{
+  grub_size_t *ctr = data;
+  (*ctr)++;
+
+  return 0;
+}
+
+static int
+fill (const char *dir, void *data)
+{
+  grub_size_t *ctr = data;
+  domid_t dom;
+  /* "dir" is just a number, at most 19 characters. */
+  char fdir[200];
+  char num[20];
+  grub_err_t err;
+  void *buf;
+  struct evtchn_alloc_unbound alloc_unbound;
+
+  /* Shouldn't happen unles some hotplug happened.  */
+  if (vdiskcnt >= *ctr)
+    return 1;
+  virtdisks[vdiskcnt].handle = grub_strtoul (dir, 0, 10);
+  if (grub_errno)
+    {
+      grub_errno = 0;
+      return 0;
+    }
+  virtdisks[vdiskcnt].fullname = 0;
+  virtdisks[vdiskcnt].backend_dir = 0;
+
+  grub_snprintf (fdir, sizeof (fdir), "device/vbd/%s/backend", dir);
+  virtdisks[vdiskcnt].backend_dir = grub_xenstore_get_file (fdir, NULL);
+  if (!virtdisks[vdiskcnt].backend_dir)
+    goto out_fail_1;
+
+  grub_snprintf (fdir, sizeof (fdir), "%s/dev",
+		 virtdisks[vdiskcnt].backend_dir);
+  buf = grub_xenstore_get_file (fdir, NULL);
+  if (!buf)
+    {
+      grub_errno = 0;
+      virtdisks[vdiskcnt].fullname = grub_xasprintf ("xenid/%s", dir);
+    }
+  else
+    {
+      virtdisks[vdiskcnt].fullname = grub_xasprintf ("xen/%s", (char *) buf);
+      grub_free (buf);
+    }
+  if (!virtdisks[vdiskcnt].fullname)
+    goto out_fail_1;
+
+  grub_snprintf (fdir, sizeof (fdir), "device/vbd/%s/backend-id", dir);
+  buf = grub_xenstore_get_file (fdir, NULL);
+  if (!buf)
+    goto out_fail_1;
+
+  dom = grub_strtoul (buf, 0, 10);
+  grub_free (buf);
+  if (grub_errno)
+    goto out_fail_1;
+
+  virtdisks[vdiskcnt].shared_page =
+    grub_xen_alloc_shared_page (dom, &virtdisks[vdiskcnt].grant);
+  if (!virtdisks[vdiskcnt].shared_page)
+    goto out_fail_1;
+
+  virtdisks[vdiskcnt].dma_page =
+    grub_xen_alloc_shared_page (dom, &virtdisks[vdiskcnt].dma_grant);
+  if (!virtdisks[vdiskcnt].dma_page)
+    goto out_fail_2;
+
+  alloc_unbound.dom = DOMID_SELF;
+  alloc_unbound.remote_dom = dom;
+
+  grub_xen_event_channel_op (EVTCHNOP_alloc_unbound, &alloc_unbound);
+  virtdisks[vdiskcnt].evtchn = alloc_unbound.port;
+
+  SHARED_RING_INIT (virtdisks[vdiskcnt].shared_page);
+  FRONT_RING_INIT (&virtdisks[vdiskcnt].ring, virtdisks[vdiskcnt].shared_page,
+		   GRUB_XEN_PAGE_SIZE);
+
+  grub_snprintf (fdir, sizeof (fdir), "device/vbd/%s/ring-ref", dir);
+  grub_snprintf (num, sizeof (num), "%u", virtdisks[vdiskcnt].grant);
+  err = grub_xenstore_write_file (fdir, num, grub_strlen (num));
+  if (err)
+    goto out_fail_3;
+
+  grub_snprintf (fdir, sizeof (fdir), "device/vbd/%s/event-channel", dir);
+  grub_snprintf (num, sizeof (num), "%u", virtdisks[vdiskcnt].evtchn);
+  err = grub_xenstore_write_file (fdir, num, grub_strlen (num));
+  if (err)
+    goto out_fail_3;
+
+  grub_snprintf (fdir, sizeof (fdir), "device/vbd/%s/protocol", dir);
+  err = grub_xenstore_write_file (fdir, XEN_IO_PROTO_ABI_NATIVE,
+				  grub_strlen (XEN_IO_PROTO_ABI_NATIVE));
+  if (err)
+    goto out_fail_3;
+
+  struct gnttab_dump_table dt;
+  dt.dom = DOMID_SELF;
+  grub_xen_grant_table_op (GNTTABOP_dump_table, (void *) &dt, 1);
+
+  grub_snprintf (fdir, sizeof (fdir), "device/vbd/%s/state", dir);
+  err = grub_xenstore_write_file (fdir, "3", 1);
+  if (err)
+    goto out_fail_3;
+
+  while (1)
+    {
+      grub_snprintf (fdir, sizeof (fdir), "%s/state",
+		     virtdisks[vdiskcnt].backend_dir);
+      buf = grub_xenstore_get_file (fdir, NULL);
+      if (!buf)
+	goto out_fail_3;
+      if (grub_strcmp (buf, "2") != 0)
+	break;
+      grub_free (buf);
+      grub_xen_sched_op (SCHEDOP_yield, 0);
+    }
+  grub_dprintf ("xen", "state=%s\n", (char *) buf);
+  grub_free (buf);
+
+  grub_snprintf (fdir, sizeof (fdir), "device/vbd/%s", dir);
+
+  virtdisks[vdiskcnt].frontend_dir = grub_strdup (fdir);
+
+  vdiskcnt++;
+  return 0;
+
+out_fail_3:
+  grub_xen_free_shared_page (virtdisks[vdiskcnt].dma_page);
+out_fail_2:
+  grub_xen_free_shared_page (virtdisks[vdiskcnt].shared_page);
+out_fail_1:
+  grub_free (virtdisks[vdiskcnt].backend_dir);
+  grub_free (virtdisks[vdiskcnt].fullname);
+
+  grub_errno = 0;
+  return 0;
+}
+
+void
+grub_xendisk_init (void)
+{
+  grub_size_t ctr = 0;
+  if (grub_xenstore_dir ("device/vbd", count, &ctr))
+    grub_errno = 0;
+
+  if (!ctr)
+    return;
+
+  virtdisks = grub_malloc (ctr * sizeof (virtdisks[0]));
+  if (!virtdisks)
+    return;
+  if (grub_xenstore_dir ("device/vbd", fill, &ctr))
+    grub_errno = 0;
+
+  grub_disk_dev_register (&grub_virtdisk_dev);
+}
+
+void
+grub_xendisk_fini (void)
+{
+  char fdir[200];
+  unsigned i;
+
+  for (i = 0; i < vdiskcnt; i++)
+    {
+      char *buf;
+      struct evtchn_close close_op = {.port = virtdisks[i].evtchn };
+
+      grub_snprintf (fdir, sizeof (fdir), "%s/state",
+		     virtdisks[i].frontend_dir);
+      grub_xenstore_write_file (fdir, "6", 1);
+
+      while (1)
+	{
+	  grub_snprintf (fdir, sizeof (fdir), "%s/state",
+			 virtdisks[i].backend_dir);
+	  buf = grub_xenstore_get_file (fdir, NULL);
+	  grub_dprintf ("xen", "state=%s\n", (char *) buf);
+
+	  if (!buf || grub_strcmp (buf, "6") == 0)
+	    break;
+	  grub_free (buf);
+	  grub_xen_sched_op (SCHEDOP_yield, 0);
+	}
+      grub_free (buf);
+
+      grub_snprintf (fdir, sizeof (fdir), "%s/ring-ref",
+		     virtdisks[i].frontend_dir);
+      grub_xenstore_write_file (fdir, NULL, 0);
+
+      grub_snprintf (fdir, sizeof (fdir), "%s/event-channel",
+		     virtdisks[i].frontend_dir);
+      grub_xenstore_write_file (fdir, NULL, 0);
+
+      grub_xen_free_shared_page (virtdisks[i].dma_page);
+      grub_xen_free_shared_page (virtdisks[i].shared_page);
+
+      grub_xen_event_channel_op (EVTCHNOP_close, &close_op);
+    }
+}
